program Graph_14;
//////////////////////////////////////////////////////////////
///       
///  (  )

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Graph in '..\Common\Graph.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  GrChars in '..\Common\GrChars.pas';

//////////////////////////////////////////////////////////////

var Gr : TGraphChars;
    NodeA, NodeB : TNode;
    S : string;

//////////////////////////////////////////////////////////////
///    TestLink  CalcSteps

procedure Save;
const CName = 'Out.txt';
var F: TextFile;
begin
  Gr.Save(CName);
  AssignFile(F, CName);
  if FileExists(CName) then Append(F) else Rewrite(F);
  Writeln(F,'- - - - - - - - - - - - - - - - - -');
  Writeln(F,'A -> B : ', Gr.TestLink(NodeA, NodeB));
  Writeln(F,'B -> A : ', Gr.TestLink(NodeB, NodeA));
  Writeln(F,'A => B : ', Gr.CalcSteps(NodeA, NodeB));
  Writeln(F,'B => A : ', Gr.CalcSteps(NodeB, NodeA));
  Writeln(F,'-----------------------------------');
  Close(F)
end;
//////////////////////////////////////////////////////////////

begin
  repeat
    Gr:= TGraphChars.GenRandom(false, 0, 0, 20, 40);
    //Gr:= TGraphChars.Load('Test_2.txt');
    Gr.Expo;
    NodeA:= Gr.GetNode('A');
    NodeB:= Gr.GetNode('B');
    Writeln('A -> B : ', Gr.TestLink(NodeA, NodeB));
    Writeln('B -> A : ', Gr.TestLink(NodeB, NodeA));
    Writeln('A => B : ', Gr.CalcSteps(NodeA, NodeB));
    Writeln('B => A : ', Gr.CalcSteps(NodeB, NodeA));
    Write('s - Save, q - Quit : '); Readln(S);
    if S='s' then Save;
    Gr.Free;
  until S='q';
end.
