program Set_02;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  SetUtils in '..\Common\SetUtils.pas',
  Assembly in '..\Common\Assembly.pas',
  Dissect in '..\Common\Dissect.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas';

//     :

function MakeSet(const arg: string): TSet;
var i: integer;
    t: TItem;
    s: string;
begin
  Result:= CreateSet;   //   
  i:=1;
  while i<= Length(arg) do begin
    //    
    while (arg[i]=#32) and (i< Length(arg)) do Inc(i);
    s:='';
    //    
    while (arg[i]<>#32) and (i<= Length(arg)) do begin
      s:= s + Upcase(arg[i]);
      Inc(i);
    end;
    Inc(i);
    t:= TItemStr.Create(s);  //  -
    if not Result.Insert(t)  //      
      then t.Free;           //   
  end;
end;


var A, B, C : TSet;   //   


begin
  try
    Assign(Output, 'Out.txt'); Rewrite(Output);
    A:= MakeSet('while if not begin var function string  end');
    B:= MakeSet('while if not integer const function string');
    C:= CreateSet;   // C = {}
    Write('      A = '); A.Expo;
    Write('      B = '); B.Expo;
    // 
    Write('    A+B = ');
    C.CopyItems(A);    C.Add(B);    C.Expo;
    // 
    Write('    A-B = ');
    C.CopyItems(A);    C.Sub(B);    C.Expo;
    // 
    Write('    A*B = ');
    C.CopyItems(A);    C.Mul(B);    C.Expo;
    //  
    Write('A xor B = ');
    C.CopyItems(A);    C.ExOr(B);    C.Expo;

    //  
    C.Free;           //    
    B.ClrAndDestroy;  //   
    B.Free;
    A.ClrAndDestroy;  //   
    A.Free;
    Close(Output);
    Assign(Output, ''); Rewrite(Output);
    Writeln('Press Enter...');
    Readln;
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
