//      

program Graph_18;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

var Gr: TGraphChars;
    Domin: TCostSet;
    S : string;
    Start, Time : TDateTime;

begin
  try
  //Assign(Output,'Out.txt'); Rewrite(Output);
  repeat
    //Gr:= TGraphChars.Load('Test2_in.txt');
    //Gr:= TGraphChars.Load('Test1_in.txt');
    //Gr:= TGraphChars.Load('Page50.txt');
    //Gr:= TGraphChars.Load('Saved.txt');
    Gr:= TGraphChars.GenRandom(false, 1, 1, 20, 50);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
    Start:= Now;

    Domin:= Gr.GenDominating;
    if Assigned(Domin) then begin
      Domin.Expo;
      Domin.ClrAndDestroy;
      Domin.Free;
    end;

    Time:= MilliSecondsBetween(Start, Now);
    Writeln('- - Dominating - -');
    Writeln('Time (ms) = ', Time:5:1);
    Readln(S);
    //if S='s' then Gr.Save('Saved.txt');
    //  
    Gr.Free;
  until S<>'';
  //Close(Output);
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
